Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4444)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4450)
@@ -25,161 +25,164 @@
 ! -----------------
 ! $Id$
+! Missing from_file check
+!
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directive moved
-! 
+!
 ! 4442 2020-03-04 19:21:13Z suehring
-! Change order of dimension in surface arrays %frac, %emissivity and %albedo 
+! Change order of dimension in surface arrays %frac, %emissivity and %albedo
 ! to allow for better vectorization in the radiation interactions.
-! 
+!
 ! 4441 2020-03-04 19:20:35Z suehring
 ! bugfix: missing cpp-directives for serial mode added, misplaced cpp-directives moved
-! 
+!
 ! 4381 2020-01-20 13:51:46Z suehring
-! - Bugfix in nested soil initialization in case no dynamic input file is 
+! - Bugfix in nested soil initialization in case no dynamic input file is
 !   present
-! - In order to do not mess-up the job-protocoll, give error messages 503, 507 
+! - In order to do not mess-up the job-protocoll, give error messages 503, 507
 !   and 508 only once
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Fix wrong location string in message call
-! 
+!
 ! 4356 2019-12-20 17:09:33Z suehring
 ! Correct single message calls, local checks must be given by the respective
 ! mpi rank.
-! 
+!
 ! 4339 2019-12-13 18:18:30Z suehring
 ! Bugfix, character length too short, caused crash on NEC.
-! 
+!
 ! 4338 2019-12-13 13:23:23Z suehring
-! To avoid divisions by zero, add security factor in calculation of roughness 
+! To avoid divisions by zero, add security factor in calculation of roughness
 ! length over water surfaces.
-! 
+!
 ! 4321 2019-12-04 10:26:38Z pavelkrc
 ! Initialization of relative surface fractions revised
-! 
+!
 ! 4312 2019-11-27 14:06:25Z suehring
 ! Bugfix: partitioning of LE from liquid water reservoir fixed. Bare soils are
 ! now allowed to store liquid water at the surface.
-! 
+!
 ! 4261 2019-10-09 17:58:00Z scharf
 ! bugfix for rev. 4258: deallocate temporary arrays
-! 
+!
 ! 4258 2019-10-07 13:29:08Z suehring
-! - Revise limitation for soil moisture in case it exceeds its saturation 
+! - Revise limitation for soil moisture in case it exceeds its saturation
 !   value (J. Resler)
-! - Revise initialization of soil moisture and temperature in a nested run in 
-!   case dynamic input information is available. This case, the soil within 
+! - Revise initialization of soil moisture and temperature in a nested run in
+!   case dynamic input information is available. This case, the soil within
 !   the child domains can be initialized separately. (J. Resler, M. Suehring)
-! - As part of this revision, migrate the netcdf input of soil temperature / 
-!   moisture to this module, as well as the routine to inter/extrapolate soil 
-!   profiles between different grids. 
-! 
+! - As part of this revision, migrate the netcdf input of soil temperature /
+!   moisture to this module, as well as the routine to inter/extrapolate soil
+!   profiles between different grids.
+!
 ! 4251 2019-10-02 12:07:38Z maronga
 ! Bugfix: albedo_types for vegetation_type look-up table corrected.
-! 
+!
 ! 4201 2019-08-29 15:47:27Z suehring
-! - Limit soil moisture to its saturation moisture and give a respective 
+! - Limit soil moisture to its saturation moisture and give a respective
 !   warning rather than an error.
 ! - Perform checks for soil temperature only when there is no dynamic input
-!   file for the parent or possible child domains. 
-! 
+!   file for the parent or possible child domains.
+!
 ! 4194 2019-08-28 08:09:44Z suehring
-! Apply more strict limitation of z0 over water surfaces in case it exceeds the 
-! surface-layer height, in order to avoid instabilities. 
-! 
+! Apply more strict limitation of z0 over water surfaces in case it exceeds the
+! surface-layer height, in order to avoid instabilities.
+!
 ! 4188 2019-08-26 14:15:47Z suehring
 ! Minor adjustment in error numbers, typos corrected
-! 
+!
 ! 4187 2019-08-26 12:43:15Z suehring
 ! Adjust message call in case of local checks
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4118 2019-07-25 16:11:45Z suehring
 ! Initialization of soil temperature and moisture via dynamic input file only
-! for vegetation and pavement surfaces. 
-! 
+! for vegetation and pavement surfaces.
+!
 ! 4110 2019-07-22 17:05:21Z suehring
-! Relax checks for non-consistent initialization in case static or dynamic 
+! Relax checks for non-consistent initialization in case static or dynamic
 ! input is provided. For example, soil_temperature or deep_soil_temperature
-! is not mandatory any more if dynamic input is available. Also, improper 
-! settings of x_type in namelist are only checked if no static file is 
-! available. 
-! 
+! is not mandatory any more if dynamic input is available. Also, improper
+! settings of x_type in namelist are only checked if no static file is
+! available.
+!
 ! 4109 2019-07-22 17:00:34Z suehring
-! Further revision of last commit in order to avoid any side effects when 
-! albedo type is not set in namelist and default albedo type changes. 
-! 
+! Further revision of last commit in order to avoid any side effects when
+! albedo type is not set in namelist and default albedo type changes.
+!
 ! 4024 2019-06-12 14:06:46Z suehring
 ! Bugfix in albedo initialization, caused crashes in rrtmg calls
-! 
+!
 ! 3987 2019-05-22 09:52:13Z kanani
 ! Introduce alternative switch for debug output during timestepping
-! 
+!
 ! 3964 2019-05-09 09:48:32Z suehring
-! In a nested child domain, distinguish between soil moisture and temperature 
+! In a nested child domain, distinguish between soil moisture and temperature
 ! initialization from parent via dynamic input file. Further, initialize soil
 ! moisture/temperature from dynamic input file only when initialization via
 ! 'inifor' is desired.
-! 
+!
 ! 3943 2019-05-02 09:50:41Z maronga
 ! Removed extra blank character
-! 
+!
 ! 3941 2019-04-30 09:48:33Z suehring
 ! Check that at least one surface type is set at surface element.
-! 
+!
 ! 3933 2019-04-25 12:33:20Z kanani
 ! Remove unused subroutine and allocation of pt_2m, this is done in surface_mod
 ! now (surfaces%pt_2m)
-! 
-! 
-! Changes related to global restructuring of location messages and introduction 
+!
+!
+! Changes related to global restructuring of location messages and introduction
 ! of additional debug messages
-! 
+!
 ! 3881 2019-04-10 09:31:22Z suehring
-! Bugfix in level 3 initialization of pavement albedo type and pavement 
+! Bugfix in level 3 initialization of pavement albedo type and pavement
 ! emissivity
-! 
+!
 ! 3868 2019-04-08 11:52:36Z suehring
-! More strict limitation of roughness length when it is in the order of the 
-! vertical grid spacing 
-! 
+! More strict limitation of roughness length when it is in the order of the
+! vertical grid spacing
+!
 ! 3856 2019-04-03 11:06:59Z suehring
 ! Bugfix in lsm_init in case no surface-fractions are provided
-! 
+!
 ! 3847 2019-04-01 14:51:44Z suehring
-! Adjust message-call for checks that are especially carried out locally. 
-! 
+! Adjust message-call for checks that are especially carried out locally.
+!
 ! 3832 2019-03-28 13:16:58Z raasch
 ! instrumented with openmp directives
-! 
+!
 ! 3786 2019-03-06 16:58:03Z raasch
 ! further unused variables removed
-! 
+!
 ! 3767 2019-02-27 08:18:02Z raasch
 ! unused variable for file index removed from rrd-subroutines parameter list
-! 
+!
 ! 3715 2019-02-04 17:34:55Z suehring
 ! Revise check for saturation moisture
-! 
+!
 ! 3710 2019-01-30 18:11:19Z suehring
 ! Check if soil-, water-, pavement- and vegetation types are set within a valid
 ! range.
-! 
+!
 ! 3692 2019-01-23 14:45:49Z suehring
 ! Revise check for soil moisture higher than its saturation value
-! 
+!
 ! 3685 2019-01-21 01:02:11Z knoop
 ! Some interface calls moved to module_interface + cleanup
-! 
+!
 ! 3677 2019-01-17 09:07:06Z moh.hefny
 ! Removed most_method
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! nopointer option removed
-! 
+!
 ! 1496 2014-12-02 17:25:50Z maronga
 ! Initial revision
-! 
+!
 !
 ! Description:
@@ -188,17 +191,17 @@
 !> surface and a multi layer soil scheme. The scheme is similar to the TESSEL
 !> scheme implemented in the ECMWF IFS model, with modifications according to
-!> H-TESSEL. The implementation is based on the formulation implemented in the 
+!> H-TESSEL. The implementation is based on the formulation implemented in the
 !> DALES and UCLA-LES models.
 !>
-!> @todo Extensive verification energy-balance solver for vertical surfaces, 
+!> @todo Extensive verification energy-balance solver for vertical surfaces,
 !>       e.g. parametrization of r_a
-!> @todo Revise single land-surface processes for vertical surfaces, e.g. 
-!>       treatment of humidity, etc. 
-!> @todo Consider partial absorption of the net shortwave radiation by the 
+!> @todo Revise single land-surface processes for vertical surfaces, e.g.
+!>       treatment of humidity, etc.
+!> @todo Consider partial absorption of the net shortwave radiation by the
 !>       skin layer.
 !> @todo Improve surface water parameterization
-!> @todo Invert indices (running from -3 to 0. Currently: nzb_soil=0, 
+!> @todo Invert indices (running from -3 to 0. Currently: nzb_soil=0,
 !>       nzt_soil=3)).
-!> @todo Implement surface runoff model (required when performing long-term LES 
+!> @todo Implement surface runoff model (required when performing long-term LES
 !>       with considerable precipitation.
 !> @todo Revise calculation of f2 when wilting point is non-constant in the
@@ -207,5 +210,5 @@
 !> @note No time step criterion is required as long as the soil layers do not
 !>       become too thin.
-!> @todo Attention, pavement_subpars_1/2 are hardcoded to 8 levels, in case 
+!> @todo Attention, pavement_subpars_1/2 are hardcoded to 8 levels, in case
 !>       more levels are used this may cause an potential bug
 !> @todo Routine calc_q_surface required?
@@ -213,5 +216,5 @@
 !------------------------------------------------------------------------------!
  MODULE land_surface_model_mod
- 
+
     USE arrays_3d,                                                             &
         ONLY:  hyp, pt, prr, q, q_p, ql, vpt, u, v, w, hyrho, exner, d_exner
@@ -235,5 +238,5 @@
                surface_pressure, timestep_scheme, tsc,                         &
                time_since_reference_point
-               
+
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point_s
@@ -274,5 +277,5 @@
                 vegetation_type_f,                                             &
                 water_pars_f,                                                  &
-                water_type_f             
+                water_type_f
 
     USE kinds
@@ -283,5 +286,5 @@
         ONLY:  albedo, albedo_type, emissivity, force_radiation_call,          &
                radiation, radiation_scheme, unscheduled_radiation_calls
-        
+
     USE statistics,                                                            &
         ONLY:  hom, statistic_regions
@@ -303,5 +306,5 @@
     REAL(wp), PARAMETER  ::                    &
               b_ch               = 6.04_wp,    & ! Clapp & Hornberger exponent
-              lambda_h_dry       = 0.19_wp,    & ! heat conductivity for dry soil (W/m/K)  
+              lambda_h_dry       = 0.19_wp,    & ! heat conductivity for dry soil (W/m/K)
               lambda_h_sm        = 3.44_wp,    & ! heat conductivity of the soil matrix (W/m/K)
               lambda_h_water     = 0.57_wp,    & ! heat conductivity of water (W/m/K)
@@ -329,5 +332,5 @@
 !-- LSM variables
     CHARACTER(10) :: surface_type = 'netcdf'      !< general classification. Allowed are:
-                                                  !< 'vegetation', 'pavement', ('building'), 
+                                                  !< 'vegetation', 'pavement', ('building'),
                                                   !< 'water', and 'netcdf'
 
@@ -339,11 +342,11 @@
                     nzs = 8,                  & !< number of soil layers
                     pavement_depth_level = 0, & !< default NAMELIST nzt_pavement
-                    pavement_type = 1,        & !< default NAMELIST pavement_type                 
+                    pavement_type = 1,        & !< default NAMELIST pavement_type
                     soil_type = 3,            & !< default NAMELIST soil_type
                     vegetation_type = 2,      & !< default NAMELIST vegetation_type
                     water_type = 1              !< default NAMELISt water_type
-                    
-   
-        
+
+
+
     LOGICAL :: conserve_water_content = .TRUE.,  & !< open or closed bottom surface for the soil model
                constant_roughness = .FALSE.,     & !< use fixed/dynamic roughness lengths for water surfaces
@@ -390,7 +393,7 @@
                 z0_water       = 9999999.9_wp,          & !< NAMELIST z0 (lsm_par)
                 z0h_water      = 9999999.9_wp,          & !< NAMELIST z0h (lsm_par)
-                z0q_water      = 9999999.9_wp             !< NAMELIST z0q (lsm_par)  
-                
-                
+                z0q_water      = 9999999.9_wp             !< NAMELIST z0q (lsm_par)
+
+
     REAL(wp), DIMENSION(:), ALLOCATABLE  :: ddz_soil_center, & !< 1/dz_soil_center
                                             ddz_soil,        & !< 1/dz_soil
@@ -400,5 +403,5 @@
 
 
-                                            
+
     REAL(wp), DIMENSION(0:20)  ::  root_fraction = 9999999.9_wp,     & !< (NAMELIST) distribution of root surface area to the individual soil layers
                                    soil_moisture = 0.0_wp,           & !< NAMELIST soil moisture content (m3/m3)
@@ -406,9 +409,9 @@
                                    dz_soil  = 9999999.9_wp,          & !< (NAMELIST) soil layer depths (spacing)
                                    zs_layer = 9999999.9_wp             !< soil layer depths (edge)
-                                 
+
     TYPE(surf_type_lsm), POINTER ::  t_soil_h,    & !< Soil temperature (K), horizontal surface elements
                                      t_soil_h_p,  & !< Prog. soil temperature (K), horizontal surface elements
                                      m_soil_h,    & !< Soil moisture (m3/m3), horizontal surface elements
-                                     m_soil_h_p     !< Prog. soil moisture (m3/m3), horizontal surface elements 
+                                     m_soil_h_p     !< Prog. soil moisture (m3/m3), horizontal surface elements
 
     TYPE(surf_type_lsm), TARGET  ::  t_soil_h_1,  & !<
@@ -421,5 +424,5 @@
                                      t_soil_v_p,  & !< Prog. soil temperature (K), vertical surface elements
                                      m_soil_v,    & !< Soil moisture (m3/m3), vertical surface elements
-                                     m_soil_v_p     !< Prog. soil moisture (m3/m3), vertical surface elements   
+                                     m_soil_v_p     !< Prog. soil moisture (m3/m3), vertical surface elements
 
     TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::&
@@ -429,8 +432,8 @@
                                      m_soil_v_2     !<
 
-    TYPE(surf_type_lsm), POINTER  ::  t_surface_h,    & !< surface temperature (K), horizontal surface elements 
-                                      t_surface_h_p,  & !< progn. surface temperature (K), horizontal surface elements 
-                                      m_liq_h,        & !< liquid water reservoir (m), horizontal surface elements 
-                                      m_liq_h_p         !< progn. liquid water reservoir (m), horizontal surface elements 
+    TYPE(surf_type_lsm), POINTER  ::  t_surface_h,    & !< surface temperature (K), horizontal surface elements
+                                      t_surface_h_p,  & !< progn. surface temperature (K), horizontal surface elements
+                                      m_liq_h,        & !< liquid water reservoir (m), horizontal surface elements
+                                      m_liq_h_p         !< progn. liquid water reservoir (m), horizontal surface elements
 
     TYPE(surf_type_lsm), TARGET   ::  t_surface_h_1,  & !<
@@ -440,8 +443,8 @@
 
     TYPE(surf_type_lsm), DIMENSION(:), POINTER  ::    &
-                                      t_surface_v,    & !< surface temperature (K), vertical surface elements 
-                                      t_surface_v_p,  & !< progn. surface temperature (K), vertical surface elements 
-                                      m_liq_v,        & !< liquid water reservoir (m), vertical surface elements 
-                                      m_liq_v_p         !< progn. liquid water reservoir (m), vertical surface elements 
+                                      t_surface_v,    & !< surface temperature (K), vertical surface elements
+                                      t_surface_v_p,  & !< progn. surface temperature (K), vertical surface elements
+                                      m_liq_v,        & !< liquid water reservoir (m), vertical surface elements
+                                      m_liq_v_p         !< progn. liquid water reservoir (m), vertical surface elements
 
     TYPE(surf_type_lsm), DIMENSION(0:3), TARGET   ::  &
@@ -456,31 +459,31 @@
                                                         m_soil_av    !< Average of m_soil
 
-    TYPE(surf_type_lsm), TARGET ::  tm_liq_h_m      !< liquid water reservoir tendency (m), horizontal surface elements 
-    TYPE(surf_type_lsm), TARGET ::  tt_surface_h_m  !< surface temperature tendency (K), horizontal surface elements 
-    TYPE(surf_type_lsm), TARGET ::  tt_soil_h_m     !< t_soil storage array, horizontal surface elements 
-    TYPE(surf_type_lsm), TARGET ::  tm_soil_h_m     !< m_soil storage array, horizontal surface elements 
-
-    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tm_liq_v_m      !< liquid water reservoir tendency (m), vertical surface elements 
-    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tt_surface_v_m  !< surface temperature tendency (K), vertical surface elements 
-    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tt_soil_v_m     !< t_soil storage array, vertical surface elements 
-    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tm_soil_v_m     !< m_soil storage array, vertical surface elements 
-
-!
-!-- Energy balance variables                
+    TYPE(surf_type_lsm), TARGET ::  tm_liq_h_m      !< liquid water reservoir tendency (m), horizontal surface elements
+    TYPE(surf_type_lsm), TARGET ::  tt_surface_h_m  !< surface temperature tendency (K), horizontal surface elements
+    TYPE(surf_type_lsm), TARGET ::  tt_soil_h_m     !< t_soil storage array, horizontal surface elements
+    TYPE(surf_type_lsm), TARGET ::  tm_soil_h_m     !< m_soil storage array, horizontal surface elements
+
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tm_liq_v_m      !< liquid water reservoir tendency (m), vertical surface elements
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tt_surface_v_m  !< surface temperature tendency (K), vertical surface elements
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tt_soil_v_m     !< t_soil storage array, vertical surface elements
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tm_soil_v_m     !< m_soil storage array, vertical surface elements
+
+!
+!-- Energy balance variables
     REAL(wp), DIMENSION(:,:), ALLOCATABLE :: &
               c_liq_av,         & !< average of c_liq
               c_soil_av,        & !< average of c_soil
               c_veg_av,         & !< average of c_veg
-              lai_av,           & !< average of lai       
+              lai_av,           & !< average of lai
               qsws_liq_av,      & !< average of qsws_liq
               qsws_soil_av,     & !< average of qsws_soil
               qsws_veg_av,      & !< average of qsws_veg
               r_s_av              !< average of r_s
-  
+
 !
 !-- Predefined Land surface classes (vegetation_type)
     CHARACTER(26), DIMENSION(0:18), PARAMETER :: vegetation_type_name = (/ &
-                                   'user defined              ',           & !  0 
-                                   'bare soil                 ',           & !  1                           
+                                   'user defined              ',           & !  0
+                                   'bare soil                 ',           & !  1
                                    'crops, mixed farming      ',           & !  2
                                    'short grass               ',           & !  3
@@ -505,5 +508,5 @@
 !-- Soil model classes (soil_type)
     CHARACTER(12), DIMENSION(0:6), PARAMETER :: soil_type_name = (/ &
-                                   'user defined',                  & ! 0 
+                                   'user defined',                  & ! 0
                                    'coarse      ',                  & ! 1
                                    'medium      ',                  & ! 2
@@ -517,5 +520,5 @@
 !-- Pavement classes
     CHARACTER(29), DIMENSION(0:15), PARAMETER :: pavement_type_name = (/ &
-                                   'user defined                 ', & ! 0 
+                                   'user defined                 ', & ! 0
                                    'asphalt/concrete mix         ', & ! 1
                                    'asphalt (asphalt concrete)   ', & ! 2
@@ -533,10 +536,10 @@
                                    'artifical turf (sports)      ', & ! 14
                                    'clay (sports)                '  & ! 15
-                                                                 /)                                                              
-                                                                 
+                                                                 /)
+
 !
 !-- Water classes
     CHARACTER(12), DIMENSION(0:5), PARAMETER :: water_type_name = (/ &
-                                   'user defined',                   & ! 0 
+                                   'user defined',                   & ! 0
                                    'lake        ',                   & ! 1
                                    'river       ',                   & ! 2
@@ -544,6 +547,6 @@
                                    'pond        ',                   & ! 4
                                    'fountain    '                    & ! 5
-                                                                  /)                                                                                  
-                    
+                                                                  /)
+
 !
 !-- Land surface parameters according to the respective classes (vegetation_type)
@@ -599,5 +602,5 @@
                                                                /), (/ 12, 18 /) )
 
-                                    
+
 !
 !-- Root distribution for default soil layer configuration (sum = 1)
@@ -618,6 +621,6 @@
                                  0.00_wp, 0.00_wp, 0.00_wp, 0.00_wp,            & ! 13
                                  0.25_wp, 0.34_wp, 0.27_wp, 0.11_wp,            & ! 14
-                                 0.23_wp, 0.36_wp, 0.30_wp, 0.11_wp,            & ! 15 
-                                 0.23_wp, 0.36_wp, 0.30_wp, 0.11_wp,            & ! 16 
+                                 0.23_wp, 0.36_wp, 0.30_wp, 0.11_wp,            & ! 15
+                                 0.23_wp, 0.36_wp, 0.30_wp, 0.11_wp,            & ! 16
                                  0.19_wp, 0.35_wp, 0.36_wp, 0.10_wp,            & ! 17
                                  0.19_wp, 0.35_wp, 0.36_wp, 0.10_wp             & ! 18
@@ -628,5 +631,5 @@
 
 !
-!-- Soil parameters  alpha_vg,      l_vg,    n_vg, gamma_w_sat,    m_sat,     m_fc,   m_wilt,    m_res 
+!-- Soil parameters  alpha_vg,      l_vg,    n_vg, gamma_w_sat,    m_sat,     m_fc,   m_wilt,    m_res
     REAL(wp), DIMENSION(0:7,1:6), PARAMETER :: soil_pars = RESHAPE( (/     &
                       3.83_wp,  1.250_wp, 1.38_wp,  6.94E-6_wp, 0.403_wp, 0.244_wp, 0.059_wp, 0.025_wp,& ! 1
@@ -641,9 +644,9 @@
 !
 !-- TO BE FILLED
-!-- Pavement parameters      z0,       z0h, albedo_type, emissivity  
+!-- Pavement parameters      z0,       z0h, albedo_type, emissivity
     REAL(wp), DIMENSION(0:3,1:15), PARAMETER :: pavement_pars = RESHAPE( (/ &
                       5.0E-2_wp, 5.0E-4_wp,     18.0_wp,    0.97_wp,  & !  1
                       5.0E-2_wp, 5.0E-4_wp,     19.0_wp,    0.94_wp,  & !  2
-                      1.0E-2_wp, 1.0E-4_wp,     20.0_wp,    0.98_wp,  & !  3                                  
+                      1.0E-2_wp, 1.0E-4_wp,     20.0_wp,    0.98_wp,  & !  3
                       1.0E-2_wp, 1.0E-4_wp,     21.0_wp,    0.93_wp,  & !  4
                       1.0E-2_wp, 1.0E-4_wp,     22.0_wp,    0.97_wp,  & !  5
@@ -651,5 +654,5 @@
                       1.0E-2_wp, 1.0E-4_wp,     24.0_wp,    0.97_wp,  & !  7
                       1.0E-2_wp, 1.0E-4_wp,     25.0_wp,    0.94_wp,  & !  8
-                      1.0E-2_wp, 1.0E-4_wp,     26.0_wp,    0.98_wp,  & !  9                                  
+                      1.0E-2_wp, 1.0E-4_wp,     26.0_wp,    0.98_wp,  & !  9
                       1.0E-2_wp, 1.0E-4_wp,     27.0_wp,    0.93_wp,  & ! 10
                       1.0E-2_wp, 1.0E-4_wp,     28.0_wp,    0.97_wp,  & ! 11
@@ -658,5 +661,5 @@
                       1.0E-2_wp, 1.0E-4_wp,     31.0_wp,    0.94_wp,  & ! 14
                       1.0E-2_wp, 1.0E-4_wp,     32.0_wp,    0.98_wp   & ! 15
-                      /), (/ 4, 15 /) )                             
+                      /), (/ 4, 15 /) )
 !
 !-- Pavement subsurface parameters part 1: thermal conductivity (W/m/K)
@@ -700,5 +703,5 @@
        1.94E6_wp, 1.94E6_wp, 1.94E6_wp, 1.94E6_wp, 1.94E6_wp, 1.94E6_wp, 9999999.9_wp, 9999999.9_wp  & ! 15
                            /), (/ 8, 15 /) )
- 
+
 !
 !-- TO BE FILLED
@@ -710,6 +713,6 @@
        283.0_wp, 0.01_wp, 0.001_wp, 1.0E10_wp, 1.0E10_wp, 1.0_wp, 0.99_wp, & ! 4
        283.0_wp, 0.01_wp, 0.001_wp, 1.0E10_wp, 1.0E10_wp, 1.0_wp, 0.99_wp  & ! 5
-                                                                     /), (/ 7, 5 /) )                                                                   
-                                                                                                                                      
+                                                                     /), (/ 7, 5 /) )
+
     SAVE
 
@@ -717,10 +720,10 @@
     PRIVATE
 
-    
+
 !
 !-- Public functions
     PUBLIC lsm_boundary_condition, lsm_check_data_output,                      &
            lsm_check_data_output_pr,                                           &
-           lsm_check_parameters, lsm_define_netcdf_grid, lsm_3d_data_averaging,& 
+           lsm_check_parameters, lsm_define_netcdf_grid, lsm_3d_data_averaging,&
            lsm_data_output_2d, lsm_data_output_3d, lsm_energy_balance,         &
            lsm_header, lsm_init, lsm_init_arrays, lsm_parin, lsm_soil_model,   &
@@ -745,13 +748,13 @@
        MODULE PROCEDURE lsm_check_data_output
     END INTERFACE lsm_check_data_output
-    
+
     INTERFACE lsm_check_data_output_pr
        MODULE PROCEDURE lsm_check_data_output_pr
     END INTERFACE lsm_check_data_output_pr
-    
+
     INTERFACE lsm_check_parameters
        MODULE PROCEDURE lsm_check_parameters
     END INTERFACE lsm_check_parameters
-    
+
     INTERFACE lsm_3d_data_averaging
        MODULE PROCEDURE lsm_3d_data_averaging
@@ -777,5 +780,5 @@
        MODULE PROCEDURE lsm_header
     END INTERFACE lsm_header
-    
+
     INTERFACE lsm_init
        MODULE PROCEDURE lsm_init
@@ -785,9 +788,9 @@
        MODULE PROCEDURE lsm_init_arrays
     END INTERFACE lsm_init_arrays
-    
+
     INTERFACE lsm_parin
        MODULE PROCEDURE lsm_parin
     END INTERFACE lsm_parin
-    
+
     INTERFACE lsm_soil_model
        MODULE PROCEDURE lsm_soil_model
@@ -812,9 +815,9 @@
 ! Description:
 ! ------------
-!> Set internal Neumann boundary condition at outer soil grid points 
-!> for temperature and humidity. 
+!> Set internal Neumann boundary condition at outer soil grid points
+!> for temperature and humidity.
 !------------------------------------------------------------------------------!
  SUBROUTINE lsm_boundary_condition
- 
+
     IMPLICIT NONE
 
@@ -879,6 +882,6 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE lsm_check_data_output( var, unit, i, ilen, k )
- 
- 
+
+
     USE control_parameters,                                                    &
         ONLY:  data_output, message_string
@@ -886,9 +889,9 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  unit  !< 
+    CHARACTER (LEN=*) ::  unit  !<
     CHARACTER (LEN=*) ::  var   !<
 
     INTEGER(iwp) :: i
-    INTEGER(iwp) :: ilen   
+    INTEGER(iwp) :: ilen
     INTEGER(iwp) :: k
 
@@ -902,5 +905,5 @@
           ENDIF
           unit = 'm3/m3'
-           
+
        CASE ( 't_soil' )
           IF (  .NOT.  land_surface )  THEN
@@ -909,6 +912,6 @@
              CALL message( 'lsm_check_data_output', 'PA0404', 1, 2, 0, 6, 0 )
           ENDIF
-          unit = 'K'   
-             
+          unit = 'K'
+
        CASE ( 'lai*', 'c_liq*', 'c_soil*', 'c_veg*', 'm_liq*',                 &
               'qsws_liq*', 'qsws_soil*', 'qsws_veg*', 'r_s*' )
@@ -969,5 +972,5 @@
           ENDIF
 
-          IF ( TRIM( var ) == 'lai*'   )      unit = 'none' 
+          IF ( TRIM( var ) == 'lai*'   )      unit = 'none'
           IF ( TRIM( var ) == 'c_liq*' )      unit = 'none'
           IF ( TRIM( var ) == 'c_soil*')      unit = 'none'
@@ -977,6 +980,6 @@
           IF ( TRIM( var ) == 'qsws_soil*' )  unit = 'W/m2'
           IF ( TRIM( var ) == 'qsws_veg*'  )  unit = 'W/m2'
-          IF ( TRIM( var ) == 'r_s*')         unit = 's/m' 
-             
+          IF ( TRIM( var ) == 'r_s*')         unit = 's/m'
+
        CASE DEFAULT
           unit = 'illegal'
@@ -995,5 +998,5 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE lsm_check_data_output_pr( variable, var_count, unit, dopr_unit )
- 
+
     USE control_parameters,                                                    &
         ONLY:  data_output_pr, message_string
@@ -1006,13 +1009,13 @@
 
     IMPLICIT NONE
-   
-    CHARACTER (LEN=*) ::  unit      !< 
-    CHARACTER (LEN=*) ::  variable  !< 
+
+    CHARACTER (LEN=*) ::  unit      !<
+    CHARACTER (LEN=*) ::  variable  !<
     CHARACTER (LEN=*) ::  dopr_unit !< local value of dopr_unit
- 
-    INTEGER(iwp) ::  var_count     !< 
+
+    INTEGER(iwp) ::  var_count     !<
 
     SELECT CASE ( TRIM( variable ) )
-       
+
        CASE ( 't_soil', '#t_soil' )
           IF (  .NOT.  land_surface )  THEN
@@ -1059,6 +1062,6 @@
 
  END SUBROUTINE lsm_check_data_output_pr
- 
- 
+
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -1070,6 +1073,6 @@
     USE control_parameters,                                                    &
         ONLY:  bc_pt_b, bc_q_b, constant_flux_layer, message_string
-                     
-    
+
+
     IMPLICIT NONE
 
@@ -1077,5 +1080,5 @@
     INTEGER(iwp) ::  j        !< running index, y-dimension
     INTEGER(iwp) ::  k        !< running index, z-dimension
-    
+
     LOGICAL      ::  dynamic_soil_input_parent !< flag indicating the presence of a dynamic input file for the parent
 
